unit CGIUnit1;

interface

uses
  SysUtils, Classes, HTTPApp, KAHTMLGrid, ADODB, DB;

type
  TWebModule1 = class(TWebModule)
    ADOConnection1: TADOConnection;
    ADOTable1: TADOTable;
    DataSource1: TDataSource;
    ADOTable2: TADOTable;
    DataSource2: TDataSource;
    ADOTable3: TADOQuery;
    KACSS1: TKACSS;
    KAHTMLGrid1: TKAHTMLGrid;
    KAHTMLGrid2: TKAHTMLGrid;
    procedure KAHTMLGrid1AfterReadData(Sender: TObject);
    procedure WebModule1WebActionItem1Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SendHTMLData;
    procedure FillPickLists;
  end;

var
  WebModule1: TWebModule1;

implementation
{$R *.DFM}
Uses
  ActiveX;

procedure TWebModule1.SendHTMLData;
Var
 SL   : TStringList;
begin
 //********************************************* COMPOSE HTML
 SL := TStringList.Create;
 Try
  SL.Add('<HTML>');
  SL.Add('<HEAD>');
  SL.Add('<style type="text/css">');
  SL.Add('<!-- ');
  SL.Add(KAHTMLGrid1.CSS.CSS.Text);
  SL.Add(' -->');
  SL.Add('</style>');
  SL.Add('</HEAD>');
  SL.Add('<BODY LEFTMARGIN="0" TOPMARGIN="0">');
  SL.Add(KAHTMLGrid1.HTML.Text);
  SL.Add('</BODY>');
  SL.Add('</HTML>');
  //********************************************* SEND TO BROWSER
  Response.Content := SL.Text;
  Response.SendResponse;
 Finally
  SL.Free;
 End;
end;

procedure TWebModule1.FillPickLists;
Begin
  AdoTable3.SQL.Clear;
  AdoTable3.SQL.Add('SELECT [EmployeeID],[LastName] FROM [Employees];');
  AdoTable3.Open;
  KAHTMLGrid1.PopulatePickListEx(AdoTable3, 'LastName','EmployeeID',3);
  AdoTable3.Close;

  AdoTable3.SQL.Clear;
  AdoTable3.SQL.Add('SELECT DISTINCT [CustomerID] FROM [Orders];');
  AdoTable3.Open;
  KAHTMLGrid1.PopulatePickList(AdoTable3,'0','2',True);
  AdoTable3.Close;
End;

procedure TWebModule1.KAHTMLGrid1AfterReadData(Sender: TObject);
begin
  KAHTMLGrid1.ColCount  := 5;
  KAHTMLGrid1.Columns[1].HAlign := alRight;
end;

procedure TWebModule1.WebModule1WebActionItem1Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
Var
  Res1 : TGridAction;
  Res2 : TGridAction;
begin
  Handled := True;
  CoInitialize(Nil);
  Try
       //*********************************************** FIRST BLOCK OF SETTINGS
       KACSS1.ModuleType       := WebModule;
       KACSS1.WebRequest       := Request;
       KACSS1.WebResponse      := Response;
       KAHTMLGrid1.RowsPerPage := 15;
       KAHTMLGrid1.ImagesURL   := 'GImages/';
       KAHTMLGrid2.ImagesURL   := 'GImages/';
       //*********************************************** REQIUIRED ACTIONS
       ADOConnection1.ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source='+KACSS1.ExePath+'NWIND.mdb;Persist Security Info=False';
       ADOConnection1.Open;
       AdoTable1.Open;
       AdoTable2.Open;
       KAHTMLGrid1.ReadValues;
       //*********************************************** ENTER EDIT MODE
       KAHTMLGrid1.EditMode  := True;
       KAHTMLGrid2.EditMode  := True;
       //*********************************************** FILL PICK LISTS FOR COLUMN 2 and 3
       FillPickLists;
       KAHTMLGrid1.Columns[3].LimitToPickList := True;
       //*********************************************** PROCESS PARAMETERS SEND FROM CLIENT
       Res1 := KAHTMLGrid1.ProcessParameters;
       Res2 := KAHTMLGrid2.ProcessParameters;
       //*********************************************** DO DEFAULT ACTION FOR EACH GRID
       if Not KAHTMLGrid1.DoDefaultAction(Res1) Then Exit;
       if Not KAHTMLGrid2.DoDefaultAction(Res2) Then Exit;
       //*********************************************** SEND HTML TO BROWSER
       SendHTMLData;
  Finally
   //*********************************************** TELL GRIDS THAT JOB IS DONE
   KAHTMLGrid1.Done;
   KAHTMLGrid2.Done;
   //*********************************************** CLEANUP
   AdoTable2.Close;
   AdoTable1.Close;
   ADOConnection1.Close;
   CoUnInitialize;
  End;
end;

end.
